import io
import mem
import sys

main() {
	length := 256
	command := mem.alloc(length)
	argv := mem.alloc(1)
	envp := mem.alloc(1)
	info := mem.alloc(24)

	loop {
		io.out("$ ")
		n := io.in(command)

		if n <= 0 {
			return
		}

		command[n-1] = '\0'
		pid := sys.fork()

		if pid == 0 {
			sys.execve(command, argv, envp)
			return
		}

		sys.waitid(0, pid, info, 4)
	}
}